
def trace_gen(f):
    """An annotation to trace the generator returned by a function."""
    def traced(*args):
        gen = f(*args)
        def gen2():
            strs = [str(a) for a in args if type(a) not in (list, tuple, dict)]
            arg_str = ', '.join(strs) 
            print('{0}({1})'.format(f.__name__, arg_str))
            for v in gen:
                yield v
        return gen2()
    return traced


